//+------------------------------------------------------------------+
//|                                                           HP.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Red

//Global constants
#define pi 3.141592653589793238462643383279502884197169399375105820974944592

//Input parameters
extern int nobs    =1000; //Number of bars to smooth
extern int lambda =15;    //Equivalent to SMA period      
double hpf[];

//Indicator buffers
double hpv[];
double hpvcum[];
//+----------------------------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,hpv);
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexBuffer(1,hpvcum);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,3);
   return(0);
}
//+----------------------------------------------------------------------------------------+
int start()
{
   double x[];
   ArrayResize(x,nobs);
   ArrayResize(hpf,nobs);
   for(int i=0;i<nobs;i++)
   {
      x[i]=(High[i]+Low[i])/2;
   }
   HPF(nobs,lambda,x,hpf);
   for(int j=0;j<nobs-2;j++)
   {
      hpv[j]=hpf[j]-hpf[j+1];
   }
   bool tozero=false;
   double velcumtmp;
   for(int k=0;k<nobs-3;k++)
   {
      if((hpv[k+1]>0&&hpv[k]<=0)||(hpv[k+1]<0&&hpv[k]>=0))
         tozero=true;
      else
         tozero=false;
      if(tozero==true)
         velcumtmp=0.0;
      else
         velcumtmp=hpv[k+1];
      hpvcum[k]=hpv[k+1]/3;
      if(k<20)
      Print(k,"  ",velcumtmp,"  ",hpvcum[k]);
   }
   //Print(hpvcum[0],"  ",hpvcum[1]);
   return(0);
}
// Hodrick-Prescott Filter-----------------------------------------------------------------+
void HPF(int nobs, double lambda, double x[], double& y[])
{
   double a[],b[],c[],H1,H2,H3,H4,H5,HH1,HH2,HH3,HH4,HH5,HB,HC,Z;
   ArrayResize(a,nobs);
   ArrayResize(b,nobs);
   ArrayResize(c,nobs);
        
   a[0]=1.0+lambda;
   b[0]=-2.0*lambda;
   c[0]=lambda;
   for(int i=1;i<nobs-2;i++)
   {
      a[i]=6.0*lambda+1.0;
      b[i]=-4.0*lambda;
      c[i]=lambda;
   }
   a[1]=5.0*lambda+1;
   a[nobs-1]=1.0+lambda;
   a[nobs-2]=5.0*lambda+1.0;
   b[nobs-2]=-2.0*lambda;
   b[nobs-1]=0.0;
   c[nobs-2]=0.0;
   c[nobs-1]=0.0;
   
   //Forward
   for(i=0;i<nobs;i++)
   {
      Z=a[i]-H4*H1-HH5*HH2;
      HB=b[i];
      HH1=H1;
      H1=(HB-H4*H2)/Z;
      b[i]=H1;
      HC=c[i];
      HH2=H2;
      H2=HC/Z;
      c[i]=H2;
      a[i]=(x[i]-HH3*HH5-H3*H4)/Z;
      HH3=H3;
      H3=a[i];
      H4=HB-H5*HH1;
      HH5=H5;
      H5=HC;
   }
   
   //Backward 
   H2=0;
   H1=a[nobs-1];
   y[nobs-1]=H1;
   for(i=nobs-2;i>=0;i--)
   {
      y[i]=a[i]-b[i]*H1-c[i]*H2;//
      H2=H1;
      H1=y[i];
   }
}

